###############################################################################
#                 Undernet Channel Service Management Script                  #
###############################################################################
# (c) 2001-2009 Yann RICHARD alias Ze <ze(arobase)nbox.org>                   #
###############################################################################

###############################################################################
# This program is distributed under the GNU General Public Licence v3         #
# See the LICENCE file for more information.                                  #
###############################################################################
#   This file is part of UndernetCS.                                          #
#                                                                             #
#   This program is free software: you can redistribute it and/or modify      #
#   it under the terms of the GNU Affero General Public License as            #
#   published by the Free Software Foundation, either version 3 of the        #
#   License, or (at your option) any later version.                           #
#                                                                             #
#   This program is distributed in the hope that it will be useful,           #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#   GNU Affero General Public License for more details.                       #
#                                                                             #
#   You should have received a copy of the GNU Affero General Public License  #
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.     #
#                                                                             #
###############################################################################

# UndernetCS:IRC:Send2X
#   Send a request to X.
#   Return: 1 on success,
#           0 otherwise.
proc UndernetCS:IRC:Send2X {arg} {
    global UndernetCS_XAdrSend botnick

    set cmd [string toupper [lindex $arg 0]]
    # Parse cmd to identify login request witch are more important
    if { $cmd == "LOGIN" } {
        putserv "PRIVMSG $UndernetCS_XAdrSend :$arg" "-next"
        return 1
    }
    # Op command is very important when it's for eggdrop ...
    if { $cmd == "OP" } {
        if { [string toupper [lindex $arg 2]] == [string toupper $botnick] } {
            # In theory this script don't send command if not auth so, it's
            # impossible with -next to send "op" before "login" command.
            putserv "PRIVMSG $UndernetCS_XAdrSend :$arg" "-next"
            return 1
        }
    }
    # Theirs command are important use putserv
    set important_cmd "DEOP BAN UNBAN CLEARMODE KICK INVITE"
    if { [lsearch -exact $important_cmd $cmd] != -1 } {
        putserv "PRIVMSG $UndernetCS_XAdrSend :$arg"
        return 1
    }
    # Others command are not important so we use puthelp
    # to send them.
    puthelp "PRIVMSG $UndernetCS_XAdrSend :$arg"
    return 1
}

### EOF ###
